//+------------------------------------------------------------------+
//|                                                   AnthonyHow.mq4 |
//|                                                   Copyright 2012 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, AnthonyHow"
//#property link      "http://www.metaquotes.net"

//--- input parameters
extern double lotsize   = 0.1;
extern int slippage     = 3;
extern int maxorders    = 3;
extern int bar          = 1;
extern int Magic        = 1234;
extern bool oneperbar   = true;              //need this

extern int starthour = 0;
extern int startminute = 0;
extern int endhour = 24;
extern int endminute = 0;
extern int entry_per_day = 3;

double takeprofit    =40;
double stoploss      =20;

#include <tradinghours.mqh>
/*
extern bool long_enabled = true;
extern bool short_enabled = true;
extern bool reverse_strategy = false;
extern bool oneperbar = true;
extern bool trade_only_signal_change = true;
extern bool trade_only_firsttick = true;
extern bool trade_on_start = false;
extern bool enableclose = true;
extern bool openafterclose = true;
extern int maxorders = 1;
extern bool _orderbymarket = false;
extern int _stealth_sl = 2;
extern int _stealth_tp = 2;
extern int _stealth_pending = 2;
extern int _magic = 1234;
extern int _sleepok = 500;
extern int _sleeperr = 1000;
*/
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+


int init()
  {
//----
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
/*int deinit()//can ignore
  {
//----
   
//----
   return(0);
  }
*/
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+


int start()
   {
   double AO4=iAO(NULL, 0, 4);                                                                        //awesome ocillator
   double AO3=iAO(NULL, 0, 3);
   double AO2=iAO(NULL, 0, 2);
   double AO1=iAO(NULL, 0, 1);
   double ACvalue=iAC(NULL, 0, 1);                                                                    //accerelator
   double jaw=iAlligator(NULL, 0, 13, 8, 8, 5, 5, 3, MODE_SMMA, PRICE_MEDIAN, MODE_GATORJAW, 1);      //alligator
   double teeth=iAlligator(NULL, 0, 13, 8, 8, 5, 5, 3, MODE_SMMA, PRICE_MEDIAN, MODE_GATORTEETH, 1);
   double lips=iAlligator(NULL, 0, 13, 8, 8, 5, 5, 3, MODE_SMMA, PRICE_MEDIAN, MODE_GATORLIPS, 1);
   double fractalup=iFractals(NULL, 0, MODE_UPPER, 3);                                                //fractal
   double fractaldown=iFractals(NULL, 0, MODE_LOWER, 3);
   int allsignal     =  0;                                                                            //signal,buy=1,sell=2,nothing=0
   int aosignal      =  0;
   int total         =  OrdersTotal();
   int cnt_entries   =  0;                                                                            //amount of trade
   
   bool enableopen   =  true;
//---------------------------------------------------------------------------------------------------------------------
//alligators signal                                                                      
      {
      if(jaw>teeth && teeth>lips)                                                                     //alligator
         {
         allsignal=2;
         }
      else if(jaw<teeth && teeth<lips)
         {
         allsignal=1;
         }
      else   allsignal=0;
      }
//---------------------------------------------------------------------------------------------------------------------
//AOsignal-twinpeak not included
      {
      if(AO1>0 && AO2>0 && AO3>0 && AO4>0)      //positive value saucer
         {
         if(AO4<AO3 && AO3>AO2 && AO2<AO1)        //saucer buy
            {
            aosignal=1;
            }
         }
      else if(AO1<0 && AO2<0 && AO3<0 && AO4<0)
         {
         if(AO4>AO3 && AO3<AO2 && AO2>AO1)        //saucer sell
            {
            aosignal=2;
            }
         }
      else aosignal=0;
      }
//---------------------------------------------------------------------------------------------------------------------
//fractal
int fsignal;
      {
      double close1 = iClose(Symbol(),0,bar);
      if (close1 > fractalup)
         {
         fsignal=1;
         }
      
      if (close1 < fractaldown) 
         {
         fsignal=2;
         }     
      }
//---------------------------------------------------------------------------------------------------------------------
//ACsignal
//weightage

//---------------------------------------------------------------------------------------------------------------------
//number of trade allowed
/*
int TotalOpenOrders;
{
  int Cnt=OrdersTotal();
  TotalOpenOrders = 0;
  if(Cnt==0)
  {
    return(0);
  }
    else
    {
    for(;Cnt>=0;Cnt--)
    {
      RefreshRates();
      OrderSelect(Cnt,SELECT_BY_POS);
      if(OrderMagicNumber()==Magic)
      {
      TotalOpenOrders++;
      }
    }
  }
  return(TotalOpenOrders);
}
*/
//---------------------------------------------------------------------------------------------------------------------
//other conditions
   if (!istradinghours(starthour,endhour,startminute,endminute))
      {
      enableopen = false;
      Comment("out of trading hours\n");
      }
   
   if (cnt_entries >= entry_per_day) 
      {
      enableopen = false;
      Comment("max entries reached\n");
      }
//---------------------------------------------------------------------------------------------------------------------
//entry-still need change,fractal in,

int ticket;
   if (allsignal==1 && total<maxorders && enableopen==true)                                                       //condition 
      {
//string symbol, int cmd, double volume, double price, int slippage, double stoploss, double takeprofit, string comment=NULL, int magic=0, datetime expiration=0, color arrow_color=CLR_NONE)
      ticket=OrderSend(Symbol(),OP_BUY,lotsize,Ask,slippage,0,0,"Order #2",NULL,Magic,Green);  //entry market buy
      if(ticket<0)
         {
         Print("OrderSend failed with error #",GetLastError());
         return(0);
         }
      }
   else if(allsignal==2 && total<maxorders)                                                       //condition 
      {
      ticket=OrderSend(Symbol(),OP_SELL,lotsize,Bid,slippage,0,0,"Order #2",NULL,Magic,Red);  //entry market sell
      if(ticket<0)
         {
         Print("OrderSend failed with error #",GetLastError());
         return(0);
         }
      }
   else Print("No signal");
//---------------------------------------------------------------------------------------------------------------------
//Close opposite
//bool OrderClose (ticket, double lots, double price, int slippage, color Color=CLR_NONE)
//---------------------------------------------------------------------------------------------------------------------
//take profit and stop loss by Point
for (int i=1; i<=OrdersTotal(); i++)            //Cycle for all orders..
     {                                          //displayed in the terminal
      if(OrdersTotal()>0)
         {
         if(OrderSelect(i-1,SELECT_BY_POS)==true)  //If there is the next one
            {                                     
            //bool OrderModify(	int ticket, double price, double stoploss, double takeprofit, datetime expiration, color arrow_color=CLR_NONE)
            OrderModify(i, OrderOpenPrice(), OrderOpenPrice()-0.002,OrderOpenPrice()+0.004,0,CLR_NONE);
            }
         }
     }                                              //End of the cycle bodyfor (int i = 1; i <= 1; i++);

//---------------------------------------------------------------------------------------------------------------------
//modify
//---------------------------------------------------------------------------------------------------------------------
//stop loss by ma
//---------------------------------------------------------------------------------------------------------------------
//ignore signal
//---------------------------------------------------------------------------------------------------------------------
   return(0);
  }

//+------------------------------------------------------------------+
/*
double SL = NormalizeDouble(iMA(NULL,0,TrailPeriod,0,MODE_SMMA,PRICE_CLOSE,1),Digits);
//-----
  int Orders = OrdersTotal();
  for (int i=0; i<Orders; i++)
  {
    if(!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) continue;
    if(OrderSymbol() != Symbol()) continue;
    {
      if(OrderType() == OP_BUY && OrderMagicNumber()==Magic && SL > OrderOpenPrice() && NormalizeDouble(Ask,Digits) > SL
      && OrderStopLoss() != SL && SL > 0 && SL!=EMPTY_VALUE && SL > OrderStopLoss())
      {
        OrderModify(OrderTicket(),OrderOpenPrice(),SL,OrderTakeProfit(),0,CLR_NONE);
      }
      if(OrderType() == OP_SELL && OrderMagicNumber()==Magic && SL < OrderOpenPrice() && NormalizeDouble(Bid,Digits) < SL
      && OrderStopLoss() != SL && SL > 0 && SL!=EMPTY_VALUE && SL < OrderStopLoss())
      {
        OrderModify(OrderTicket(),OrderOpenPrice(),SL,OrderTakeProfit(),0,CLR_NONE);
      }
    }
  }
*/


